'---
' Set up SAPI for clip generation
'---

public sub VoiceS4Init()

On Error Resume Next

  set oTTS = WScript.CreateObject("ActiveVoice.ActiveVoice", "TTS_")
  If Err.Number <> 0 Then
     Err.Clear

  Set oTTS = WScript.CreateObject("ActiveVoice.ActiveVoice.1", "TTS_")
    If Err.Number <> 0 Then
    Set RB_progress = FSO.CreateTextFile(ScriptDir&"\error.rbc")
    ' Microsoft Sapi4 non trovata o non installata correttamente
    RB_progress.Write("1")
    RB_progress.Close
    Err.Clear
    WScript.Quit
    End If
  End If
    
  nMode = oTTS.Find("Speaker=" & Sapi4Name & ";ModeName=" & Sapi4Name)
  If oTTS.Speaker(nMode) <> Sapi4Name And oTTS.ModeName(nMode) <> Sapi4Name Then

    Set RB_progress = FSO.CreateTextFile(ScriptDir&"\error.rbc")
    ' La voce Sapi4 non  installata
    RB_progress.Write("2")
    RB_progress.Close
    Err.Clear
    WScript.Quit
  End If
    
  oTTS.Initialized = 1
  oTTS.CallbacksEnabled = 1
  oTTS.Select nMode

End sub

Public Sub VoiceS5Init()

On Error Resume Next

  Set spkr = WSCript.CreateObject("SAPI.SpVoice")
  If Err.Number <> 0 Then
    ' Microsoft Speech sapi5 non  installata.
    Set RB_progress = FSO.CreateTextFile(ScriptDir&"\error.rbc")
    RB_progress.Write("3")
    RB_progress.Close
    Err.clear
    WScript.Quit
  End If

'--- Attempt to load voice.

  Set spkr.Voice = spkr.GetVoices(VoiceName).Item(0)

  If Err.Number <> 0 Then
    ' La voce selezionata sembra non essere installata.
    Set RB_progress = FSO.CreateTextFile(ScriptDir&"\error.rbc")
    RB_progress.Write("4")
    RB_progress.Close
    Err.clear
    Wscript.Quit
  End If

  On Error GoTo 0 ' reset error handling
  Err.clear 

'--- Set speech characteristics - volume and rate (no pitch?)

  spkr.Rate   = VoiceRate     '-10 <--> +10
  spkr.Volume = VoiceVolume    '  0 <--> 100
  Set SpFS = Wscript.CreateObject("SAPI.SpFileStream")
  SpFS.Format.Type = Audio_Format

End Sub

'--- Subroutine to enumerate all folders and "voiced" files in a folder.
'--- Traverses folders recursively. See function "isVoiced" for filtering rules.

Public Sub VoiceCheck(Item)

 Dim ThisFolder, LastSlash, LastDot, ClipSpeak, WavFile, TalkFile

 If (FSO.FolderExists(Item)) Then

'----- Open the parent folder

   Set ThisFolder = FSO.GetFolder(Item)

'--- Process items in this folder

   If (VoiceFolders) Then

     LastSlash = InStrRev(Item,"\",-1,1)
     ClipSpeak = Right(Item,Len(Item)-LastSlash)

     WavFile  = Item&"\_dirname.wav"
     TalkFile = Item&"\_dirname.talk"

   If (Overwrite_dotTalk or (not FSO.FileExists(TalkFile))) Then
     CountDir = CountDir + 1
     ClipList_file.WriteLine("1"&Item)
 CountClip = CountClip + 1
 StepTime = Timer - TimeStart
 if StepTime > StepStart then
    Set RB_progress = FSO.CreateTextFile(ScriptDir&"\find.rbc")
     RB_progress.Write(CountClip)
    RB_progress.Close
 TimeStart = Timer
 End If
   End If

'     Call TextToMP3(ClipSpeak,WavFile,TalkFile)

   Else

   End If

   If (ThisFolder.Files.Count <> 0) Then

     For Each File In ThisFolder.Files

       If (VoiceFiles) Then

         ClipSpeak = File.Name

         If (isVoiced(File.Name)) Then

           WavFile  = Item&"\"&ClipSpeak&".wav"
           TalkFile = Item&"\"&ClipSpeak&".talk"

   If (Overwrite_dotTalk or (not FSO.FileExists(TalkFile))) Then
      CountFile = CountFile + 1
     ClipList_file.WriteLine("2"&Item&"\"&ClipSpeak)
 CountClip = CountClip + 1
 StepTime = Timer - TimeStart
 if StepTime > StepStart then
    Set RB_progress = FSO.CreateTextFile(ScriptDir&"\find.rbc")
     RB_progress.Write(CountClip)
    RB_progress.Close
 TimeStart = Timer
 End If
   End If

'            Call TextToMP3(ClipSpeak,WavFile,TalkFile)

         Else

         End If

       End If

     Next

   End If

'--- Process subfolders

   If (ThisFolder.SubFolders.Count <> 0) Then

     For Each Folder In ThisFolder.SubFolders

        Call VoiceCheck(Folder)

     Next

   End If

   Set ThisFolder = Nothing

 ElseIf (FSO.FileExists(Item)) Then

   If (VoiceFiles) Then

     If (isVoiced(Item)) Then

       LastSlash = InStrRev(Item,"\",-1,1)
       ClipSpeak = Right(Item,Len(Item)-LastSlash)
       WavFile  = Item&".wav"
       TalkFile = Item&".talk"

   If (Overwrite_dotTalk or (not FSO.FileExists(TalkFile))) Then
      CountFile = CountFile + 1
     ClipList_file.WriteLine("2"&Item&"\"&ClipSpeak)
 CountClip = CountClip + 1
 StepTime = Timer - TimeStart
 if StepTime > StepStart then
    Set RB_progress = FSO.CreateTextFile(ScriptDir&"\find.rbc")
     RB_progress.Write(CountClip)
    RB_progress.Close
 TimeStart = Timer
 End If
   End If

'        Call TextToMP3(ClipSpeak,WavFile,TalkFile)

     Else

     End If

   End If

 Else

 End If

End Sub 'voiceCheck

'===============================================================================
' Function to determine whether a given file is to be voiced or not.
' Edit the file name matching rules below as you see fit
'===============================================================================

function isVoiced(Name)

  isVoiced = false

'--- General case

  If ((LCase(Right(Name,3))="mp3") or _
      (LCase(Right(Name,3))="mpc") or _
      (LCase(Right(Name,3))="ape") or _
      (LCase(Right(Name,3))="asf") or _
      (LCase(Right(Name,3))="wma") or _
      (LCase(Right(Name,3))="mac") or _
      (LCase(Right(Name,3))="mpa") or _
      (LCase(Right(Name,3))="sid") or _
      (LCase(Right(Name,3))="mp4") or _
      (LCase(Right(Name,3))="m4a") or _
      (LCase(Right(Name,3))="mp1") or _
      (LCase(Right(Name,3))="mp2") or _
      (LCase(Right(Name,3))="wav") or _
      (LCase(Right(Name,2))="wv") or _
      (LCase(Right(Name,3))="wmv") or _
      (LCase(Right(Name,3))="aif") or _
      (LCase(Right(Name,4))="aiff") or _
      (LCase(Right(Name,3))="ogg") or _
      (LCase(Right(Name,4))="flac") or _
      (LCase(Right(Name,3))="ac3") or _
      (LCase(Right(Name,3))="a52") or _
      (LCase(Right(Name,3))="adx") or _
      (LCase(Right(Name,3))="shn") or _
      (LCase(Right(Name,3))="nsf") or _
      (LCase(Right(Name,3))="spc") or _
      (LCase(Right(Name,4))="nsfe") or _
      (LCase(Right(Name,3))="mod") or _
      (LCase(Right(Name,3))="spx") or _
      (LCase(Right(Name,3))="cue") or _
      (LCase(Right(Name,3))="m3u") or _
      (LCase(Right(Name,4))="m3u8") or _
      (LCase(Right(Name,3))="mid") or _
      (LCase(Right(Name,3))="rif") or _
      (LCase(Right(Name,3))="txt") or _
      (LCase(Right(Name,3))="nfo") or _
      (LCase(Right(Name,3))="jpg") or _
      (LCase(Right(Name,4))="jpeg") or _
      (LCase(Right(Name,3))="mpg") or _
      (LCase(Right(Name,4))="mpeg") or _
      (LCase(Right(Name,3))="lng") or _
      (LCase(Right(Name,3))="wps") or _
      (LCase(Right(Name,4))="rwps") or _
      (LCase(Right(Name,3))="fnt") or _
      (LCase(Right(Name,3))="fmr") or _
      (LCase(Right(Name,5))="bmark") or _
      (LCase(Right(Name,4))="rock") or _
      (LCase(Right(Name,4))="link") or _
      (LCase(Right(Name,3))="cfg") or _
      (LCase(Right(Name,3))="kbd") or _
      (LCase(Right(Name,3))="ajz") or _
      (LCase(Right(Name,3))="mi4") or _
      (LCase(Right(Name,4))="ipod") or _
      (LCase(Right(Name,6))="iriver") or _
      (LCase(Right(Name,8))="gigabeat") or _
      (LCase(Right(Name,6))="iaudio")) then

    isVoiced = true

  End If

end function 'isVoiced


Public Sub TextToMP3(Text,WaveFile,MP3File)

  Dim cmdRun, retval
  If (Overwrite_dotTalk or (not FSO.FileExists(MP3File))) Then

  If (Overwrite_dotWav or not FSO.FileExists(WaveFile)) Then

'--- Speak text directly to the .wav file

  Text = Replace(Text,"_"," ")
  Text = Replace(Text,","," ")
  Text = Replace(Text,";"," ")
  Text = Replace(Text,"("," ")
  Text = Replace(Text,")"," ")
  Text = Replace(Text,"+"," ")
  Text = Replace(Text,"="," ")
  Text = Replace(Text,"~"," ")
  Text = Replace(Text,"  "," ")
  Text = Replace(Text,"wma","wm a")
  Text = Replace(Text,"mpa","m p a")
  Text = Replace(Text,"adx","a d x")
  Text = Replace(Text,"asf","a s f")
  Text = Replace(Text,"bmark","b mark")
  Text = Replace(Text,"jpeg","j peg")
  Text = Replace(Text,"jpg","j p g")
  Text = Replace(Text,"mpeg","m peg")
  Text = Replace(Text,"nfo","n f o")
  Text = Replace(Text,"ogg","o g g")
  Text = Replace(Text,"shn","s h n")

  ' speaktext Text,WaveFile

On Error Resume Next

  if VoiceName = "Name=Sapi4" then

    oTTS.Filename = WaveFile
    oTTS.Speed= (VoiceRate * 25) + 250
    oTTS.Pitch= 120
    oTTS.Speak Text

    If Err.Number <> 0 Then
      Set RB_progress = FSO.CreateTextFile(ScriptDir&"\error.rbc")
      RB_progress.Write("5")
      RB_progress.Close
      Set RB_progress = FSO.CreateTextFile(ScriptDir&"\error.log")
      RB_progress.WriteLine("Generate clip sapi4")
      RB_progress.WriteLine(Err.Number & " = " & Err.Description)
      RB_progress.Close
      Err.clear
      WScript.Quit
    End If

    While oTTS.Speaking
      WScript.Sleep 1
    Wend
    oTTS.Filename =""

  else

    SpFS.Open WaveFile, SSFMCreateForWrite, False
    Set spkr.AudioOutputStream = SpFS
    spkr.Speak(Text)

    If Err.Number <> 0 Then
      Set RB_progress = FSO.CreateTextFile(ScriptDir&"\error.rbc")
      RB_progress.Write("6")
      RB_progress.Close
      Set RB_progress = FSO.CreateTextFile(ScriptDir&"\error.log")
      RB_progress.WriteLine("Generate clip sapi5")
      RB_progress.Write(Err.Number & " = " & Err.Description)
      RB_progress.Close
      Err.clear
      WScript.Quit
    End If

    SpFS.Close

  end If ' Sapi4 or sapi5
  End If

'--- Send command line to wave encoding application.
'--- Quote encoder path, just to be safe. (spaces in absolute pathname?)

  If (FSO.FileExists(WaveFile)) Then
  cmdRun = dQ&encodeApp&dQ&sP&EncOpts&sP&dQ&WaveFile&dQ&sP&dQ&Mp3File&dQ
  retval = Shell.Run(cmdRun,7,true)
  End If

  Else

  End If

'---  Delete the wave file after encoding if RemoveWav is set to true

  If (RemoveWav and FSO.FileExists(WaveFile)) Then
  cmdRun = "  -->Deleting file "&WaveFile
  FSO.DeleteFile(WaveFile)
  End If

End Sub


public sub Open_ClipList()

  Set ClipList_file = FSO.OpenTextFile(ScriptDir&"\Clip_List.txt")

  Set Log_file = FSO.CreateTextFile(ScriptDir&"\Report.txt")
  CurDate = Date
  CurTime = Time
  Log_file.WriteLine("   - Start report: "&CurDate&", "&CurTime)

  While Not ClipList_file.AtEndOfStream

  Item = ClipList_file.ReadLine

  ' controlla il tipo di oggetto, cartella o file
  ClipType = Left(Item,1)
  Item = Right(Item,Len(Item)-1)

  ' Scrive sul file RB_progress lo stato della crreazione delle clip
  CountClip = CountClip + 1
  StepTime = Timer - TimeStart
  if StepTime > StepStart then
    Set RB_progress = FSO.CreateTextFile(ScriptDir&"\progress.rbc")
    RB_progress.Write(CountClip)
    RB_progress.Close
    TimeStart = timer
  End If

  ' in caso di cartella

  If ClipType = "1" then
    WavFile  = Item&"\_dirname.wav"
    TalkFile = Item&"\_dirname.talk"
    LastSlash = InStrRev(Item,"\",-1,1)
    ClipSpeak = Right(Item,Len(Item)-LastSlash)

    CountDir = CountDir + 1
    Log_file.WriteLine("Folder "&CountDir&": "&Item)

  Else

  ' in caso di file

    WavFile  = Item&".wav"
    TalkFile = Item&".talk"

    If Mid(item,3,9) = "\.rockbox" or StripExt = true then
      LastDot   = InStrRev(Item,".",-1,1)
      Item = Left(Item,LastDot-1)
    End If

    LastSlash = InStrRev(Item,"\",-1,1)
    ClipSpeak = Right(Item,Len(Item)-LastSlash)

    CountFile = CountFile + 1
    Log_file.WriteLine("File "&CountFile&": "&Item)

  End If

  Call TextToMP3(ClipSpeak,WavFile,TalkFile)
        
  Wend

  CurDate = Date
  CurTime = Time
  Log_file.WriteLine("   - End report:   "&CurDate&", "&CurTime)
  Log_file.Close

End Sub
